﻿@model System.Collections.IEnumerable

@{
    var gridSetting = ((Toyota.Common.Web.Html.Helper.DevExpress.CommonGridLookupSettings)(TempData["Grid" + TempData["GridName"]]));
    TempData["Grid" + TempData["GridName"]] = gridSetting;
    TempData["GridName"] = gridSetting.Name;
}

@Html.DevExpress().GridView(
    settings =>
    {
        settings.Name = "Grid" + gridSetting.Name;
        settings.Width = gridSetting.GridProperties.Width;
        settings.Height = gridSetting.GridProperties.Height;
        settings.SettingsBehavior.AllowSelectSingleRowOnly = gridSetting.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly;
        settings.SettingsBehavior.AllowSelectByRowClick = true;
        settings.Settings.ShowFilterRow = true;
        settings.Settings.ShowFilterRowMenu = true;
        settings.CallbackRouteValues = gridSetting.GridProperties.CallbackRouteValues;

        settings.CommandColumn.Visible = true;
        settings.CommandColumn.ShowSelectCheckbox = true;
        settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(30);

        if (settings.SettingsBehavior.AllowSelectSingleRowOnly == false)
        {
            settings.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(settingsCheckBox =>
                    {
                        settingsCheckBox.Name = "SelectAllCheckBox" + gridSetting.Name;
                        settingsCheckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", settings.Name);
                        settingsCheckBox.Checked = c.Grid.Selection.Count > 1;
                        settingsCheckBox.ClientVisible = !gridSetting.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly;
                    }).Render();
            });
        }
        else
        {
            settings.ClientSideEvents.SelectionChanged = gridSetting.GridProperties.ClientSideEvents.SelectionChanged;
        }

        if (gridSetting.GridProperties.Columns != null)
        {
            foreach (MVCxGridViewColumn column in gridSetting.GridProperties.Columns)
            {
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                settings.Columns.Add(column);
            }
        }

        settings.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        settings.Styles.AlternatingRow.Enabled = DefaultBoolean.True;

        settings.SettingsDetail.AllowOnlyOneMasterRowExpanded = false;
        settings.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;

        settings.SettingsPager.PageSizeItemSettings.Visible = settings.SettingsPager.PageSizeItemSettings.Visible;
        settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100", "200" };
        settings.SettingsPager.PageSizeItemSettings.Caption = "Page size";
        settings.SettingsPager.FirstPageButton.Visible = true;
        settings.SettingsPager.LastPageButton.Visible = true;
        settings.SettingsPager.PageSize = gridSetting.GridProperties.SettingsPager.PageSize;



        settings.SettingsPager.AlwaysShowPager = gridSetting.GridProperties.SettingsPager.AlwaysShowPager;

        settings.SettingsPager.NumericButtonCount = 10;
        //settings.Settings.VerticalScrollableHeight = 155;
        settings.Settings.VerticalScrollableHeight = gridSetting.GridProperties.Settings.VerticalScrollableHeight;


        settings.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        if (gridSetting.GridProperties.KeyFieldName != null)
        {
            settings.KeyFieldName = gridSetting.GridProperties.KeyFieldName;
        }
        //settings.ClientSideEvents.SelectionChanged = gridSetting.GridProperties.ClientSideEvents.SelectionChanged;
        // Added by : fid.salman 25-peb-2013
        // Desc     : to perform supplier plant binding by supplier gridlookup selection. therefor supplierplant
        //            gridlookup need to able perform call back.
        if (gridSetting.GridProperties.ClientSideEvents.BeginCallback != "")
            settings.ClientSideEvents.BeginCallback = gridSetting.GridProperties.ClientSideEvents.BeginCallback;

        
        if (gridSetting.GridProperties.ClientSideEvents.EndCallback != "")
            settings.ClientSideEvents.EndCallback = gridSetting.GridProperties.ClientSideEvents.EndCallback; 
    }).Bind(Model).GetHtml()